## akonadi 25.11.80

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

set(PIM_VERSION "6.5.80")
project(Akonadi VERSION ${PIM_VERSION})

# ECM setup
set(KF_MIN_VERSION "6.18.0")
set(QT_REQUIRED_VERSION "6.8.0")

find_package(ECM ${KF_MIN_VERSION} CONFIG REQUIRED)

set(CMAKE_MODULE_PATH
    ${ECM_MODULE_PATH}
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules
)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(GenerateExportHeader)
include(ECMGenerateHeaders)

include(ECMSetupVersion)
include(KDEGitCommitHooks)
include(KDEClangFormat)
file(
    GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES
    *.cpp
    *.h
    *.c
)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

include(CheckAtomic)
include(CheckIncludeFiles)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(ECMFeatureSummary)
include(CheckSymbolExists)

include(KDEPackageAppTemplates)
include(ECMMarkNonGuiExecutable)
include(ECMAddTests)
include(ECMSetupQtPluginMacroNames)
include(ECMQmlModule)

include(AkonadiMacros)
include(ECMAddQch)

option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(
    QCH
    ${BUILD_QCH}
    "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)"
)

set(RELEASE_SERVICE_VERSION "25.11.80")
set(AKONADI_FULL_VERSION "${PIM_VERSION} (${RELEASE_SERVICE_VERSION})")

configure_file(akonadifull-version.h.in ${CMAKE_CURRENT_BINARY_DIR}/akonadifull-version.h @ONLY)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_SCAN_FOR_MODULES OFF)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)

ecm_setup_version(PROJECT
    VARIABLE_PREFIX AKONADI
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/akonadi_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KPim6AkonadiConfigVersion.cmake"
    SOVERSION 6
)

# Find packages
find_package(Qt6Core ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6Sql ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6DBus ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6Network ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6Test ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6Widgets ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6Xml ${QT_REQUIRED_VERSION} REQUIRED)
find_package(Qt6Quick ${QT_REQUIRED_VERSION} REQUIRED)

find_package(KF6Config ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6ConfigWidgets ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6CoreAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6I18n ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6IconThemes ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6ItemModels ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6WidgetsAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6XmlGui ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Crash ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6WindowSystem ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6ColorScheme ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(Qt6Designer NO_MODULE)
set_package_properties(
    Qt6Designer
    PROPERTIES
        PURPOSE
            "Required to build the Qt Designer plugins"
        TYPE
            OPTIONAL
)

option(BUILD_DESIGNERPLUGIN "Build plugin for Qt Designer" ON)
add_feature_info(
    DESIGNERPLUGIN
    ${BUILD_DESIGNERPLUGIN}
    "Build plugin for Qt Designer"
)

set(AccountsQt6_MINIMUM_VERSION "1.16")
find_package(AccountsQt6 ${AccountsQt6_MINIMUM_VERSION})
set_package_properties(
    AccountsQt6
    PROPERTIES
        DESCRIPTION
            "Qt bindings for the Accounts framework"
        URL
            "https://gitlab.com/accounts-sso/libaccounts-qt"
        TYPE
            OPTIONAL
)
set(KAccounts_MINIMUM_VERSION "19.08.0")
find_package(KAccounts6 ${KAccounts_MINIMUM_VERSION})
set_package_properties(
    KAccounts6
    PROPERTIES
        DESCRIPTION
            "KDE library for Accounts framework integration"
        URL
            "https://invent.kde.org/network/kaccounts-integration"
        TYPE
            OPTIONAL
)
if(${AccountsQt6_FOUND} AND ${KAccounts6_FOUND})
    set(WITH_ACCOUNTS TRUE)
endif()

set(LibLZMA_MINIMUM_VERSION "5.0.0")
find_package(LibLZMA ${LibLZMA_MINIMUM_VERSION})
set_package_properties(
    LibLZMA
    PROPERTIES
        DESCRIPTION
            "LZMA compression library"
        URL
            "https://tukaani.org/xz/"
        TYPE
            REQUIRED
)

if(BUILD_TESTING)
    set(AKONADI_TESTS_EXPORT AKONADICORE_EXPORT)
    set(AKONADIWIDGET_TESTS_EXPORT AKONADIWIDGETS_EXPORT)
    add_definitions(-DBUILD_TESTING)
endif()

ecm_setup_qtplugin_macro_names(
    JSON_ARG2
        "AKONADI_AGENTCONFIG_FACTORY"
    CONFIG_CODE_VARIABLE
        PACKAGE_SETUP_AUTOMOC_VARIABLES
)

# Make sure the KF6Akonadi_DATA_DIR is absolute before passing it to KF6AkonadiConfig.cmake.in
# otherwise build fails either on OSX CI, or for normal users
if(IS_ABSOLUTE "${KDE_INSTALL_DATADIR_KF}")
    set(KF5Akonadi_DATA_DIR "${KDE_INSTALL_DATADIR_KF}/akonadi")
else()
    set(KF5Akonadi_DATA_DIR "${CMAKE_INSTALL_PREFIX}/${KDE_INSTALL_DATADIR_KF}/akonadi")
endif()

check_symbol_exists(
    malloc_trim
    "malloc.h"
    HAVE_MALLOC_TRIM
)

############### Build Options ###############
option(BUILD_TOOLS "Build and install tools for development and testing purposes." TRUE)
option(INSTALL_APPARMOR "Install AppArmor profiles" TRUE)

if(BUILD_TESTING)
    set(BUILD_TOOLS TRUE)
endif()

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if(USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
    add_definitions(-DCOMPILE_WITH_UNITY_CMAKE_SUPPORT)
endif()
set(SharedMimeInfo_MINIMUM_VERSION "1.10")
find_package(SharedMimeInfo ${SharedMimeInfo_MINIMUM_VERSION} REQUIRED)

find_program(XSLTPROC_EXECUTABLE xsltproc)
if(NOT XSLTPROC_EXECUTABLE)
    message(
        FATAL_ERROR
        "\nThe command line XSLT processor program 'xsltproc'  could not be found.\nPlease install xsltproc.\n"
    )
endif()

find_program(
    MYSQLD_EXECUTABLE
    NAMES
        mariadbd
        mysqld
    PATHS
        /usr/sbin
        /usr/local/sbin
        /usr/libexec
        /usr/local/libexec
        /opt/mysql/libexec
        /usr/mysql/bin
        /opt/mysql/sbin
    DOC "The mariadbd or mysqld executable path. ONLY needed at runtime"
)

string(FIND ${MYSQLD_EXECUTABLE} "mariadb" _Position)
set(MYSQLDB_INSTALL_EXEC "mariadb-install-db")
if(${_Position} LESS 0)
    set(MYSQLDB_INSTALL_EXEC "mysql_install_db")
endif()

find_path(
    MYSQLD_SCRIPTS_PATH
    NAMES
        ${MYSQLDB_INSTALL_EXEC}
    DOC "Path to the mariadb or mysql installation scripts (mariadb-install-db, mariadb-upgrade...)"
)

if(MYSQLD_EXECUTABLE)
    message(STATUS "MySQL Server found: ${MYSQLD_EXECUTABLE}")
else()
    message(STATUS "MySQL Server wasn't found. it is required to use an MySQL backend (like mariadb or mysqld.")
endif()

if(MYSQLD_SCRIPTS_PATH)
    message(STATUS "MySQL scripts location: ${MYSQLD_SCRIPTS_PATH}")
else()
    message(STATUS "MySQL scripts location was not found. Use -DMYSQLD_SCRIPTS_PATH to point to the install location.")
endif()

find_path(
    POSTGRES_PATH
    NAMES
        pg_ctl
    HINTS
        /usr/lib${LIB_SUFFIX}/postgresql/8.4/bin
        /usr/lib${LIB_SUFFIX}/postgresql/9.0/bin
        /usr/lib${LIB_SUFFIX}/postgresql/9.1/bin
    DOC "The pg_ctl executable path. ONLY needed at runtime by the PostgreSQL backend"
)

if(POSTGRES_PATH)
    message(STATUS "PostgreSQL Server found.")
else()
    message(STATUS "PostgreSQL wasn't found. it is required to use the Postgres backend.")
endif()

find_program(XMLLINT_EXECUTABLE xmllint)
if(NOT XMLLINT_EXECUTABLE)
    message(STATUS "xmllint not found, skipping akonadidb.xml schema validation")
endif()

check_include_files(
    unistd.h
    HAVE_UNISTD_H
)

if(IS_ABSOLUTE "${KDE_INSTALL_DBUSINTERFACEDIR}")
    set(AKONADI_DBUS_INTERFACES_INSTALL_DIR "${KDE_INSTALL_DBUSINTERFACEDIR}")
else()
    set(AKONADI_DBUS_INTERFACES_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${KDE_INSTALL_DBUSINTERFACEDIR}")
endif()

if(IS_ABSOLUTE "${KDE_INSTALL_INCLUDEDIR}/KPim6")
    set(AKONADI_INCLUDE_DIR "${KDE_INSTALL_INCLUDEDIR}/KPim6")
else()
    set(AKONADI_INCLUDE_DIR "${CMAKE_INSTALL_PREFIX}/${KDE_INSTALL_INCLUDEDIR}/KPim6")
endif()

############### Build Options ###############

include(CTest) # Calls enable_testing().

if(NOT DEFINED DATABASE_BACKEND)
    set(DATABASE_BACKEND
        "MYSQL"
        CACHE STRING
        "The default database backend to use for Akonadi. Can be either MYSQL, POSTGRES or SQLITE"
    )
endif()

############### Macros ###############

macro(SET_DEFAULT_DB_BACKEND)
    set(_backend ${ARGV0})
    if("${_backend}" STREQUAL "SQLITE")
        set(AKONADI_DATABASE_BACKEND QSQLITE)
    elseif("${_backend}" STREQUAL "POSTGRES")
        set(AKONADI_DATABASE_BACKEND QPSQL)
    elseif("${_backend}" STREQUAL "MYSQL")
        set(AKONADI_DATABASE_BACKEND QMYSQL)
    else()
        message(
            FATAL_ERROR
            "Invalid database backend \"${_backend}\". Supported values are MYSQL, POSTGRES and SQLITE."
        )
    endif()

    message(STATUS "Using default db backend ${AKONADI_DATABASE_BACKEND}")
endmacro()

#### DB BACKEND DEFAULT ####
set_default_db_backend(${DATABASE_BACKEND})

############### Compilers flags ###############

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_C_COMPILER MATCHES "icc" OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
    set(CMAKE_C_FLAGS
        "${CMAKE_C_FLAGS} -Wno-long-long -std=iso9899:1990 -Wundef -Wcast-align -Werror-implicit-function-declaration -Wchar-subscripts -Wall -Wextra -Wpointer-arith -Wwrite-strings -Wformat-security -Wmissing-format-attribute -fno-common"
    )
    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wundef -Wcast-align -Wchar-subscripts -Wall -Wextra -Wpointer-arith -Wformat-security -fno-common -pedantic"
    )
    check_cxx_compiler_flag(
        -Wno-deprecated-copy
        NO_DEPRECATED_COPY
    )
    if(NO_DEPRECATED_COPY)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-copy")
    endif()

    set(CMAKE_CXX_FLAGS_DEBUGFULL
        "-g3 -fno-inline"
        CACHE STRING
        "Flags used by the C++ compiler during debugfull builds."
        FORCE
    )
    set(CMAKE_C_FLAGS_DEBUGFULL
        "-g3 -fno-inline"
        CACHE STRING
        "Flags used by the C compiler during debugfull builds."
        FORCE
    )
    mark_as_advanced(
        CMAKE_CXX_FLAGS_DEBUGFULL
        CMAKE_C_FLAGS_DEBUGFULL
    )
elseif(MSVC)
    # This sets the __cplusplus macro to a real value based on the version of C++ specified by
    # the /std switch. Without it MSVC keeps reporting C++98, so feature detection doesn't work.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus")
endif()

if(MSVC)
    set(_ENABLE_EXCEPTIONS -EHsc)
else()
    set(_ENABLE_EXCEPTIONS -fexceptions)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_ENABLE_EXCEPTIONS}")

############### Configure files #############

configure_file(config-akonadi.h.in ${Akonadi_BINARY_DIR}/config-akonadi.h)

############### build targets ###############
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KPim6Akonadi")
add_definitions(-DTRANSLATION_DOMAIN=\"libakonadi6\")

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    src
)

add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
ecm_set_disabled_deprecation_versions(QT 6.10.0  KF 6.20.0)

add_subdirectory(src)
add_subdirectory(icons)

add_subdirectory(templates)

if(BUILD_TOOLS)
    # add testrunner (application for managing a self-contained
    # test environment)
    add_subdirectory(autotests/libs/testrunner)
    add_subdirectory(autotests/libs/testresource)
    add_subdirectory(autotests/libs/testsearchplugin)
endif()

if(BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(tests)
endif()

if(INSTALL_APPARMOR)
    add_subdirectory(apparmor)
endif()

=== apparmor/CMakeLists.txt ===
install(
    FILES
        usr.bin.akonadiserver
        mariadbd_akonadi
        mysqld_akonadi
        postgresql_akonadi
    DESTINATION ${KDE_INSTALL_SYSCONFDIR}/apparmor.d
)

=== autotests/CMakeLists.txt ===
find_package(
    Qt6
    ${QT_REQUIRED_VERSION}
    CONFIG
    REQUIRED
        Test
        DBus
)

if(${EXECUTABLE_OUTPUT_PATH})
    set(PREVIOUS_EXEC_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
else()
    set(PREVIOUS_EXEC_OUTPUT_PATH .)
endif()
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})
set(TEST_RESULT_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/testresults)
file(MAKE_DIRECTORY ${TEST_RESULT_OUTPUT_PATH})

option(AKONADI_TESTS_XML "Use XML files for the test results, instead of plain text." FALSE)
option(AKONADI_RUN_SQLITE_ISOLATED_TESTS "Run isolated tests with sqlite3 as backend" TRUE)
option(AKONADI_RUN_MYSQL_ISOLATED_TESTS "Run isolated tests with MySQL as backend" TRUE)
option(AKONADI_RUN_PGSQL_ISOLATED_TESTS "Run isolated tests with PostgreSQL as backend" TRUE)

kde_enable_exceptions()

# convenience macro to add akonadi qtestlib unit-tests
macro(add_akonadi_test _source)
    set(_test
        ${_source}
        ${CMAKE_BINARY_DIR}/src/core/akonadicore_debug.cpp
    )
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(TEST_NAME ${_name} ${_test})
    set_tests_properties(
        ${_name}
        PROPERTIES
            ENVIRONMENT
                "QT_HASH_SEED=0;QT_NO_CPU_FEATURE=sse4.2"
    )
    target_link_libraries(
        ${_name}
        akonaditestfake
        Qt::Test
        KPim6::AkonadiPrivate
        KF6::I18n
    )
endmacro()

# convenience macro to add akonadi qtestlib unit-tests
macro(add_akonadi_test_widgets _source)
    set(_test
        ${_source}
        ${CMAKE_BINARY_DIR}/src/widgets/akonadiwidgets_debug.cpp
        ${CMAKE_BINARY_DIR}/src/core/akonadicore_debug.cpp
    )
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(TEST_NAME ${_name} ${_test})
    set_tests_properties(
        ${_name}
        PROPERTIES
            ENVIRONMENT
                "QT_HASH_SEED=0;QT_NO_CPU_FEATURE=sse4.2"
    )
    target_link_libraries(
        ${_name}
        akonaditestfake
        Qt::Test
        KPim6::AkonadiWidgets
        KPim6::AkonadiPrivate
    )
endmacro()

include(../KPimAkonadiMacros.cmake)

add_subdirectory(private)
add_subdirectory(server)
add_subdirectory(libs)
add_subdirectory(akonadicontrol)
add_subdirectory(shared)
add_subdirectory(widgets)

=== autotests/akonadicontrol/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

macro(add_unit_test _source)
    set(_test
        ${_source}
        ${Akonadi_BINARY_DIR}/src/akonadicontrol/akonadicontrol_debug.cpp
        ${Akonadi_SOURCE_DIR}/src/akonadicontrol/agenttype.cpp
    )

    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(TEST_NAME ${_name} NAME_PREFIX "AkonadiControl-" ${_test})
    add_dependencies(${_name} akonadi_control)
    target_include_directories(${_name} BEFORE PRIVATE $<TARGET_PROPERTY:akonadi_control,INTERFACE_INCLUDE_DIRECTORIES>)
    if(ENABLE_ASAN)
        set_tests_properties(
            AkonadiControl-${_name}
            PROPERTIES
                ENVIRONMENT
                    ASAN_OPTIONS=symbolize=1
        )
    endif()
    target_link_libraries(
        ${_name}
        akonadi_shared
        KPim6::AkonadiPrivate
        Qt::Test
        KF6::ConfigCore
        ${CMAKE_EXE_LINKER_FLAGS_ASAN}
    )
endmacro()

add_unit_test(agenttypetest.cpp)

=== autotests/libs/CMakeLists.txt ===
# akonadi test fake library
set(akonaditestfake_xml ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.NotificationSource.xml)
set_source_files_properties(
    ${akonaditestfake_xml}
    PROPERTIES
        INCLUDE
            "protocol_p.h"
)
qt_add_dbus_interface( akonaditestfake_srcs ${akonaditestfake_xml} notificationsourceinterface)

add_library(
    akonaditestfake
    SHARED
    ${akonaditestfake_srcs}
    fakeakonadiservercommand.cpp
    fakesession.cpp
    fakemonitor.cpp
    fakeserverdata.cpp
    modelspy.cpp
    fakeentitycache.cpp
    inspectablemonitor.cpp
    inspectablechangerecorder.cpp
    fakeakonadiservercommand.h
    fakesession.h
    fakemonitor.h
    fakeserverdata.h
    modelspy.h
    fakeentitycache.h
    inspectablemonitor.h
    inspectablechangerecorder.h
)

generate_export_header(akonaditestfake BASE_NAME akonaditestfake)

target_link_libraries(
    akonaditestfake
    Qt::DBus
    KPim6::AkonadiCore
    Qt::Test
    Qt::Network
    KPim6::AkonadiPrivate
    akonadi_shared
)

add_executable(
    akonadi-firstrun
    ../../src/core/firstrun.cpp
    firstrunner.cpp
    ${CMAKE_BINARY_DIR}/src/core/akonadicore_debug.cpp
)
target_link_libraries(
    akonadi-firstrun
    Qt::Test
    Qt::Core
    KPim6::AkonadiCore
    KPim6::AkonadiPrivate
    KF6::ConfigCore
)

add_akonadi_test(itemhydratest.cpp itemhydratest.h)
add_akonadi_test(itemtest.cpp itemtest.h)
add_akonadi_test(itemserializertest.cpp itemserializertest.h)
add_akonadi_test(mimetypecheckertest.cpp mimetypecheckertest.h)
add_akonadi_test(protocolhelpertest.cpp)
add_akonadi_test(entitytreemodeltest.cpp)
add_akonadi_test(monitornotificationtest.cpp)
add_akonadi_test(collectionutilstest.cpp)
add_akonadi_test(collectionannotationsattributetest.cpp)
add_akonadi_test(collectioncolorattributetest.cpp)
add_akonadi_test(entitydisplayattributetest.cpp)
add_akonadi_test(proxymodelstest.cpp)
add_akonadi_test_widgets(actionstatemanagertest.cpp)
add_akonadi_test_widgets(conflictresolvedialogtest.cpp conflictresolvedialogtest.h)
add_akonadi_test(tagmodeltest.cpp)
add_akonadi_test(statisticsproxymodeltest.cpp)

add_akonadi_test(sharedvaluepooltest.cpp)
add_akonadi_test(jobtest.cpp)
add_akonadi_test(tagtest_simple.cpp)
add_akonadi_test(cachepolicytest.cpp cachepolicytest.h)
add_akonadi_test(itemchangelogtest.cpp)

# PORT FROM QJSON add_akonadi_test(searchquerytest.cpp)

# qtestlib tests that need non-exported stuff from
#add_executable(resourceschedulertest resourceschedulertest.cpp resourceschedulertest.h ../src/agentbase/resourcescheduler.cpp)
#add_test( resourceschedulertest resourceschedulertest)
#ecm_mark_as_test(akonadi-resourceschedulertest)
#target_link_libraries(resourceschedulertest  Qt::Test KPim6::AkonadiAgentBase)

# testrunner tests
add_akonadi_isolated_test(SOURCE testenvironmenttest.cpp)
add_akonadi_isolated_test(SOURCE autoincrementtest.cpp autoincrementtest.h)
add_akonadi_isolated_test(SOURCE attributefactorytest.cpp attributefactorytest.h)
add_akonadi_isolated_test(SOURCE collectionpathresolvertest.cpp collectionpathresolvertest.h)
add_akonadi_isolated_test(SOURCE collectionattributetest.cpp collectionattributetest.h)
add_akonadi_isolated_test(SOURCE itemfetchtest.cpp itemfetchtest.h)
add_akonadi_isolated_test(SOURCE itemappendtest.cpp itemappendtest.h)
add_akonadi_isolated_test(SOURCE itemstoretest.cpp itemstoretest.h)
add_akonadi_isolated_test(SOURCE itemdeletetest.cpp)
add_akonadi_isolated_test(SOURCE entitycachetest.cpp)
add_akonadi_isolated_test(SOURCE monitortest.cpp monitortest.h)
#add_akonadi_isolated_test_advanced(monitorfiltertest.cpp "" "KPim6::AkonadiPrivate")
# FIXME: this is constantly failing due to broken search: re-enable once the new search code is merged
#add_akonadi_isolated_test(SOURCE searchjobtest.cpp searchjobtest.h)
add_akonadi_isolated_test(SOURCE changerecordertest.cpp)
add_akonadi_isolated_test(SOURCE resourcetest.cpp)
add_akonadi_isolated_test(SOURCE subscriptiontest.cpp)
add_akonadi_isolated_test(SOURCE transactiontest.cpp transactiontest.h)
add_akonadi_isolated_test(SOURCE itemcopytest.cpp)
add_akonadi_isolated_test(SOURCE itemmovetest.cpp)
add_akonadi_isolated_test(SOURCE invalidatecachejobtest.cpp)
add_akonadi_isolated_test(SOURCE collectioncreatetest.cpp)
add_akonadi_isolated_test(SOURCE collectioncopytest.cpp)
add_akonadi_isolated_test(SOURCE collectionmovetest.cpp)
add_akonadi_isolated_test(
    SOURCE  collectionsynctest.cpp
    ADDITIONAL_SOURCES ${CMAKE_BINARY_DIR}/src/core/akonadicore_debug.cpp
    LINK_LIBRARIES KF6::I18n
)
add_akonadi_isolated_test(SOURCE itemsynctest.cpp)
add_akonadi_isolated_test(SOURCE linktest.cpp)
add_akonadi_isolated_test(SOURCE cachetest.cpp)
add_akonadi_isolated_test(SOURCE collectionjobtest.cpp collectionjobtest.h)
add_akonadi_isolated_test(SOURCE collectionmodifytest.cpp)

# FIXME: This is very unstable on Jenkins
#add_akonadi_isolated_test(servermanagertest.cpp)

# Having a benchmark is cool if you have any reference to compare against, but this
# benchmark takes over 40 seconds and does not have any real value to us atm. Major
# performance regressions would be spotted by devs anyway, so disabling for now.
#add_akonadi_isolated_test(itembenchmark.cpp)
#add_akonadi_isolated_test(collectioncreator.cpp)

add_akonadi_isolated_test(SOURCE gidtest.cpp gidtest.h)
add_akonadi_isolated_test(SOURCE lazypopulationtest.cpp)
add_akonadi_isolated_test(SOURCE favoriteproxytest.cpp LINK_LIBRARIES KF6::ConfigCore)
# FIXME: this is constantly failing due to broken search: re-enable once the new search code is merged
#add_akonadi_isolated_test(
#    SOURCE itemsearchjobtest.cpp searchjobtest.h
#    ADDITIONAL_SOURCES testsearchplugin/testsearchplugin.cpp)
add_akonadi_isolated_test(SOURCE tagtest.cpp ADDITIONAL_SOURCES ${CMAKE_BINARY_DIR}/src/core/akonadicore_debug.cpp)
add_akonadi_isolated_test(SOURCE tagsynctest.cpp)
add_akonadi_isolated_test(SOURCE etmpopulationtest.cpp)

=== autotests/private/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

macro(add_unit_test _source)
    set(_test ${_source})
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(TEST_NAME ${_name} NAME_PREFIX "AkonadiPrivate-" ${_source})
    if(ENABLE_ASAN)
        set_tests_properties(
            AkonadiPrivate-${_name}
            PROPERTIES
                ENVIRONMENT
                    ASAN_OPTIONS=symbolize=1
        )
    endif()
    target_link_libraries(
        ${_name}
        akonadi_shared
        KPim6::AkonadiPrivate
        Qt::Network
        Qt::Test
        ${CMAKE_EXE_LINKER_FLAGS_ASAN}
    )
endmacro()

add_unit_test(akstandarddirstest.cpp)
add_unit_test(akdbustest.cpp)
add_unit_test(notificationmessagetest.cpp notificationmessagetest.h)
add_unit_test(externalpartstoragetest.cpp)
add_unit_test(protocoltest.cpp protocoltest.h)
add_unit_test(imapparsertest.cpp imapparsertest.h)
add_unit_test(imapsettest.cpp imapsettest.h)
add_unit_test(compressionstreamtest.cpp)
add_unit_test(datastreamtest.cpp)

=== autotests/server/CMakeLists.txt ===
########### next target ###############

# QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
remove_definitions(-DQT_GUI_LIB)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

akonadi_run_xsltproc(
    XSL ${Akonadi_SOURCE_DIR}/src/server/storage/schema.xsl
    XML ${CMAKE_CURRENT_SOURCE_DIR}/dbtest_data/unittest_schema.xml
    BASENAME unittestschema
    CLASSNAME UnitTestSchema
)
akonadi_run_xsltproc(
    XSL ${CMAKE_CURRENT_SOURCE_DIR}/dbpopulator.xsl
    XML ${CMAKE_CURRENT_SOURCE_DIR}/dbtest_data/dbdata.xml
    BASENAME dbpopulator
)

set_property(
    SOURCE
        ${CMAKE_CURRENT_BINARY_DIR}/dbpopulator.cpp
    PROPERTY
        SKIP_AUTOMOC
            TRUE
)

add_library(akonadi_unittest_common STATIC)
target_sources(
    akonadi_unittest_common
    PRIVATE
        unittestschema.cpp
        fakeconnection.cpp
        fakeintervalcheck.cpp
        fakedatastore.cpp
        fakeclient.cpp
        fakeakonadiserver.cpp
        fakesearchmanager.cpp
        fakeitemretrievalmanager.cpp
        dbinitializer.cpp
        inspectablenotificationcollector.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/dbpopulator.cpp
        fakeconnection.h
        fakeintervalcheck.h
        fakedatastore.h
        fakeclient.h
        fakeakonadiserver.h
        fakesearchmanager.h
        fakeitemretrievalmanager.h
        dbinitializer.h
        inspectablenotificationcollector.h
)

target_link_libraries(
    akonadi_unittest_common
    KPim6::AkonadiPrivate
    libakonadiserver
    Qt::Core
    Qt::DBus
    Qt::Test
    Qt::Sql
    Qt::Network
)

macro(add_server_test _source)
    set(_test
        ${_source}
        ../../src/server/akonadiserver_debug.cpp
        ../../src/server/akonadiserver_search_debug.cpp
        dbtest_data/dbtest_data.qrc
    )
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(TEST_NAME ${_name} NAME_PREFIX "AkonadiServer-" ${_test})
    if(ENABLE_ASAN)
        set_tests_properties(
            AkonadiServer-${_name}
            PROPERTIES
                ENVIRONMENT
                    ASAN_OPTIONS=symbolize=1
        )
    endif()
    set_tests_properties(
        AkonadiServer-${_name}
        PROPERTIES
            ENVIRONMENT
                "QT_HASH_SEED=0;QT_NO_CPU_FEATURE=sse4.2"
    )
    target_link_libraries(
        ${_name}
        akonadi_shared
        akonadi_unittest_common
        libakonadiserver
        KPim6::AkonadiPrivate
        Qt::Core
        Qt::DBus
        Qt::Test
        Qt::Sql
        Qt::Network
        ${CMAKE_SHARED_LINKER_FLAGS_ASAN}
    )
endmacro()

add_server_test(dbdeadlockcatchertest.cpp)
add_server_test(dbtypetest.cpp)
add_server_test(dbintrospectortest.cpp)
add_server_test(querybuildertest.cpp)
add_server_test(dbinitializertest.cpp dbinitializertest.h)
add_server_test(dbupdatertest.cpp dbupdatertest.h)
add_server_test(handlertest.cpp)
add_server_test(dbconfigtest.cpp)
add_server_test(parthelpertest.cpp)
add_server_test(itemretrievertest.cpp)
add_server_test(notificationsubscribertest.cpp)
add_server_test(notificationmanagertest.cpp)
add_server_test(parttypehelpertest.cpp)
add_server_test(collectionstatisticstest.cpp)
add_server_test(aggregatedfetchscopetest.cpp)
add_server_test(collectionschedulertest.cpp)
add_server_test(partstreamertest.cpp)
add_server_test(itemcreatehandlertest.cpp)
add_server_test(itemlinkhandlertest.cpp)
add_server_test(itemmovehandlertest.cpp)
add_server_test(collectioncreatehandlertest.cpp)
add_server_test(collectionfetchhandlertest.cpp)
add_server_test(collectionmodifyhandlertest.cpp)
add_server_test(searchtest.cpp akonadiprivate)
add_server_test(taghandlertest.cpp akonadiprivate)
add_server_test(fetchhandlertest.cpp akonadiprivate)
add_server_test(querycachetest.cpp)

add_akonadi_isolated_test(SOURCE dbdatetimetest.cpp LINK_LIBRARIES libakonadiserver)

=== autotests/shared/CMakeLists.txt ===
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

macro(add_unit_test _source)
    set(_test ${_source})
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(TEST_NAME ${_name} NAME_PREFIX "AkonadiShared-" ${_source})
    if(ENABLE_ASAN)
        set_tests_properties(
            AkonadiShared-${_name}
            PROPERTIES
                ENVIRONMENT
                    ASAN_OPTIONS=symbolize=1
        )
    endif()
    target_link_libraries(
        ${_name}
        akonadi_shared
        Qt::Test
        ${CMAKE_EXE_LINKER_FLAGS_ASAN}
    )
endmacro()

add_unit_test(akrangestest.cpp)

=== src/agentbase/CMakeLists.txt ===
# base install include dir
set(AkonadiAgentBase_INSTALL_INCLUDEDIR "${KDE_INSTALL_INCLUDEDIR}/KPim6/AkonadiAgentBase")

add_library(KPim6AkonadiAgentBase)
add_library(KPim6::AkonadiAgentBase ALIAS KPim6AkonadiAgentBase)

ecm_qt_declare_logging_category(KPim6AkonadiAgentBase HEADER akonadiagentbase_debug.h IDENTIFIER AKONADIAGENTBASE_LOG CATEGORY_NAME org.kde.pim.akonadiagentbase
        DESCRIPTION "akonadi (Akonadi AgentBase Library)"
        OLD_CATEGORY_NAMES akonadiagentbase_log
        EXPORT AKONADI
)

ecm_generate_headers(AkonadiAgentBase_CC_HEADERS
    HEADER_NAMES
    AccountsIntegration
    AgentBase
    AgentSearchInterface
    PreprocessorBase
    ResourceBase
    ResourceSettings
    TransportResourceBase
    REQUIRED_HEADERS AkonadiAgentBase_HEADERS
    PREFIX Akonadi
)

kconfig_add_kcfg_files(KPim6AkonadiAgentBase resourcebasesettings.kcfgc)

qt_add_dbus_interfaces(akonadiagentbase_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Tracer.xml)

qt_add_dbus_adaptor(akonadiagentbase_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Resource.xml
    resourcebase.h Akonadi::ResourceBase resourceadaptor Akonadi__ResourceAdaptor
)
qt_add_dbus_adaptor(akonadiagentbase_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Preprocessor.xml
    preprocessorbase_p.h Akonadi::PreprocessorBasePrivate preprocessoradaptor Akonadi__PreprocessorAdaptor
)
qt_add_dbus_adaptor(akonadiagentbase_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Agent.Status.xml
    agentbase.h Akonadi::AgentBase statusadaptor Akonadi__StatusAdaptor
)
qt_add_dbus_adaptor(akonadiagentbase_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Agent.Control.xml
    agentbase.h Akonadi::AgentBase controladaptor Akonadi__ControlAdaptor
)
qt_add_dbus_adaptor(akonadiagentbase_SRCS ../interfaces/org.freedesktop.Akonadi.Resource.Transport.xml
    transportresourcebase_p.h Akonadi::TransportResourceBasePrivate transportadaptor Akonadi__TransportAdaptor
)
qt_add_dbus_adaptor(akonadiagentbase_SRCS ../interfaces/org.freedesktop.Akonadi.Agent.Search.xml
                     agentsearchinterface_p.h Akonadi::AgentSearchInterfacePrivate searchadaptor Akonadi__SearchAdaptor
)
qt_add_dbus_adaptor(akonadiagentbase_SRCS ../interfaces/org.kde.Akonadi.Accounts.xml
    accountsintegration.h Akonadi::AccountsIntegration accountsadaptor Akonadi__AccountsAdaptor
)

target_sources(
    KPim6AkonadiAgentBase
    PRIVATE
        accountsintegration.cpp
        agentbase.cpp
        agentsearchinterface.cpp
        preprocessorbase.cpp
        preprocessorbase_p.cpp
        recursivemover.cpp
        resourcebase.cpp
        resourcescheduler.cpp
        resourcesettings.cpp
        transportresourcebase.cpp
        accountsintegration.h
        agentbase.h
        agentbase_p.h
        agentsearchinterface.h
        preprocessorbase.h
        preprocessorbase_p.h
        recursivemover_p.h
        resourcebase.h
        resourcescheduler_p.h
        resourcesettings.h
        transportresourcebase.h
        ${akonadiagentbase_SRCS}
)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(
        KPim6AkonadiAgentBase
        PROPERTIES
            UNITY_BUILD
                ON
    )
endif()

generate_export_header(KPim6AkonadiAgentBase BASE_NAME akonadiagentbase)

target_include_directories(
    KPim6AkonadiAgentBase
    INTERFACE
        "$<INSTALL_INTERFACE:${AkonadiAgentBase_INSTALL_INCLUDEDIR}>"
)

target_link_libraries(
    KPim6AkonadiAgentBase
    PUBLIC
        Qt::DBus
        KPim6::AkonadiCore
        KF6::ConfigCore
        KF6::ConfigGui # for KConfigSkeleton
    PRIVATE
        KPim6::AkonadiPrivate
        KF6::I18n
        Qt::Network
        akonadi_shared
)

if(WITH_ACCOUNTS)
    target_link_libraries(
        KPim6AkonadiAgentBase
        PRIVATE
            KAccounts6
            Qt::Xml
    )
    target_include_directories(KPim6AkonadiAgentBase PRIVATE ${ACCOUNTSQT_INCLUDE_DIRS})
endif()

set_target_properties(
    KPim6AkonadiAgentBase
    PROPERTIES
        VERSION
            ${AKONADI_VERSION}
        SOVERSION
            ${AKONADI_SOVERSION}
        EXPORT_NAME
            AkonadiAgentBase
)

install(TARGETS KPim6AkonadiAgentBase EXPORT KPim6AkonadiTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/akonadiagentbase_export.h
        ${CMAKE_CURRENT_BINARY_DIR}/resourcebasesettings.h
        ${AkonadiAgentBase_HEADERS}
    DESTINATION ${AkonadiAgentBase_INSTALL_INCLUDEDIR}/akonadi
    COMPONENT Devel
)

install(FILES ${AkonadiAgentBase_CC_HEADERS} DESTINATION ${AkonadiAgentBase_INSTALL_INCLUDEDIR}/Akonadi COMPONENT Devel)

install(FILES resourcebase.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

if(BUILD_QCH)
    ecm_add_qch(
        KPim6AkonadiAgent_QCH
        NAME KPim6AkonadiAgent
        BASE_NAME KPim6AkonadiAgent
        VERSION ${PIM_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
        ${AkonadiAgentBase_HEADERS}
        #MD_MAINPAGE "${CMAKE_SOURCE_DIR}/README.md"
        #IMAGE_DIRS "${CMAKE_SOURCE_DIR}/docs/pics"
        LINK_QCHS
            Qt6Core_QCH
            Qt6Gui_QCH
        INCLUDE_DIRS
            ${CMAKE_CURRENT_BINARY_DIR}
        BLANK_MACROS
            AKONADICORE_EXPORT
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )
endif()

## Widgets

set(AkonadiAgentWidgetBase_INSTALL_INCLUDEDIR "${KDE_INSTALL_INCLUDEDIR}/KPim6/AkonadiAgentWidgetBase")

add_library(KPim6AkonadiAgentWidgetBase)
add_library(KPim6::AkonadiAgentWidgetBase ALIAS KPim6AkonadiAgentWidgetBase)

ecm_generate_headers(AkonadiAgentWidgetBase_CC_HEADERS
    HEADER_NAMES
    AgentWidgetBase
    ResourceWidgetBase
    REQUIRED_HEADERS AkonadiAgentWidgetBase_HEADERS
    PREFIX Akonadi
)

target_sources(
    KPim6AkonadiAgentWidgetBase
    PRIVATE
        agentwidgetbase.cpp
        resourcewidgetbase.cpp
        agentwidgetbase.h
        resourcewidgetbase.h
)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(
        KPim6AkonadiAgentWidgetBase
        PROPERTIES
            UNITY_BUILD
                ON
    )
endif()

generate_export_header(KPim6AkonadiAgentWidgetBase BASE_NAME akonadiagentwidgetbase)

target_include_directories(
    KPim6AkonadiAgentWidgetBase
    INTERFACE
        "$<INSTALL_INTERFACE:${AkonadiAgentWidgetBase_INSTALL_INCLUDEDIR}>"
)

target_link_libraries(
    KPim6AkonadiAgentWidgetBase
    PUBLIC
        Qt::Widgets # for QApplication
        KPim6AkonadiAgentBase
    PRIVATE
        KPim6::AkonadiWidgets
        KF6::IconThemes
)

set_target_properties(
    KPim6AkonadiAgentWidgetBase
    PROPERTIES
        VERSION
            ${AKONADI_VERSION}
        SOVERSION
            ${AKONADI_SOVERSION}
        EXPORT_NAME
            AkonadiAgentWidgetBase
)

install(TARGETS KPim6AkonadiAgentWidgetBase EXPORT KPim6AkonadiTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/akonadiagentwidgetbase_export.h
        ${AkonadiAgentWidgetBase_HEADERS}
    DESTINATION ${AkonadiAgentWidgetBase_INSTALL_INCLUDEDIR}/akonadi
    COMPONENT Devel
)

install(
    FILES
        ${AkonadiAgentWidgetBase_CC_HEADERS}
    DESTINATION ${AkonadiAgentWidgetBase_INSTALL_INCLUDEDIR}/Akonadi
    COMPONENT Devel
)

if(BUILD_QCH)
    ecm_add_qch(
        KPim6AkonadiWidgetAgent_QCH
        NAME KPim6AkonadiWidgetAgent
        BASE_NAME KPim6AkonadiWidgetAgent
        VERSION ${PIM_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
        ${AkonadiAgentWidgetBase_HEADERS}
        #MD_MAINPAGE "${CMAKE_SOURCE_DIR}/README.md"
        #IMAGE_DIRS "${CMAKE_SOURCE_DIR}/docs/pics"
        LINK_QCHS
            Qt6Core_QCH
            Qt6Gui_QCH
            Qt6Widgets_QCH
        INCLUDE_DIRS
            ${CMAKE_CURRENT_BINARY_DIR}
        BLANK_MACROS
            AKONADICORE_EXPORT
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )
endif()

=== src/agentserver/CMakeLists.txt ===
add_executable(akonadi_agent_server)
# Agent server
target_sources(
    akonadi_agent_server
    PRIVATE
        agentpluginloader.cpp
        agentserver.cpp
        agentthread.cpp
        main.cpp
        agentpluginloader.h
        agentserver.h
        agentthread.h
)

ecm_qt_declare_logging_category(akonadi_agent_server HEADER akonadiagentserver_debug.h IDENTIFIER AKONADIAGENTSERVER_LOG CATEGORY_NAME org.kde.pim.akonadiagentserver
        DESCRIPTION "akonadi (Akonadi Agent Server)"
        OLD_CATEGORY_NAMES log_akonadiagentserver
        EXPORT AKONADI
)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(
        akonadi_agent_server
        PROPERTIES
            UNITY_BUILD
                ON
    )
endif()

set_target_properties(
    akonadi_agent_server
    PROPERTIES
        MACOSX_BUNDLE
            FALSE
)

target_link_libraries(
    akonadi_agent_server
    akonadi_shared
    KPim6::AkonadiPrivate
    Qt::Core
    Qt::DBus
)

# Agent plugin launcher
add_executable(akonadi_agent_launcher)
target_sources(
    akonadi_agent_launcher
    PRIVATE
        agentpluginloader.cpp
        agentlauncher.cpp
        akonadiagentserver_debug.cpp
        agentpluginloader.h
)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(
        akonadi_agent_launcher
        PROPERTIES
            UNITY_BUILD
                ON
    )
endif()

set_target_properties(
    akonadi_agent_launcher
    PROPERTIES
        MACOSX_BUNDLE
            FALSE
)

target_link_libraries(
    akonadi_agent_launcher
    akonadi_shared
    KPim6::AkonadiPrivate
    Qt::Core
    Qt::Widgets
)

# Install both helper apps.
install(TARGETS akonadi_agent_launcher DESTINATION ${BIN_INSTALL_DIR})

install(
    TARGETS
        akonadi_agent_server
        ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

=== src/akonadicontrol/CMakeLists.txt ===
########### next target ###############
add_executable(akonadi_control)

if(WITH_ACCOUNTS)
    target_sources(
        akonadi_control
        PRIVATE
            accountsintegration.cpp
            accountsintegration.h
    )
endif()

ecm_qt_declare_logging_category(akonadi_control HEADER akonadicontrol_debug.h IDENTIFIER AKONADICONTROL_LOG CATEGORY_NAME org.kde.pim.akonadicontrol
        DESCRIPTION "akonadi (Akonadi Control)"
        EXPORT AKONADI
)

qt_add_dbus_adaptor(control_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.AgentManager.xml agentmanager.h AgentManager)
qt_add_dbus_adaptor(control_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.ControlManager.xml controlmanager.h ControlManager)
qt_add_dbus_adaptor(control_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.AgentManagerInternal.xml agentmanager.h AgentManager)
qt_add_dbus_interfaces(control_SRCS
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Agent.Control.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Agent.Status.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Agent.Search.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.AgentServer.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Resource.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Preprocessor.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Server.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.kde.Akonadi.Accounts.xml
)
qt_add_dbus_interface(control_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.ResourceManager.xml resource_manager)
qt_add_dbus_interface(control_SRCS ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.PreprocessorManager.xml preprocessor_manager)

target_sources(
    akonadi_control
    PRIVATE
        agenttype.cpp
        agentinstance.cpp
        agentbrokeninstance.cpp
        agentprocessinstance.cpp
        agentthreadinstance.cpp
        agentmanager.cpp
        controlmanager.cpp
        processcontrol.cpp
        main.cpp
        ${control_SRCS}
        agenttype.h
        agentinstance.h
        agentbrokeninstance.h
        agentprocessinstance.h
        agentthreadinstance.h
        agentmanager.h
        controlmanager.h
        processcontrol.h
)
if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(
        akonadi_control
        PROPERTIES
            UNITY_BUILD
                ON
    )
endif()

target_include_directories(akonadi_control BEFORE PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)

set_target_properties(
    akonadi_control
    PROPERTIES
        MACOSX_BUNDLE
            FALSE
)
set_target_properties(
    akonadi_control
    PROPERTIES
        OUTPUT_NAME
            akonadi_control
)

if(WIN32)
    set_target_properties(
        akonadi_control
        PROPERTIES
            WIN32_EXECUTABLE
                TRUE
    )
    target_link_libraries(akonadi_control ${QT_QTMAIN_LIBRARY})
endif()

target_link_libraries(
    akonadi_control
    akonadi_shared
    KPim6::AkonadiPrivate
    KF6::CoreAddons
    KF6::ConfigCore
    Qt::Core
    Qt::DBus
    Qt::Gui
)

if(WITH_ACCOUNTS)
    target_include_directories(akonadi_control PRIVATE ${ACCOUNTSQT_INCLUDE_DIRS})
    # We need Qt::Xml because the Accounts framework leaks QDocument includes into public interface
    target_link_libraries(
        akonadi_control
        ${ACCOUNTSQT_LIBRARIES}
        Qt::Xml
    )
endif()

install(
    TARGETS
        akonadi_control
        ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

configure_file(
    org.freedesktop.Akonadi.Control.service.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Akonadi.Control.service
)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Akonadi.Control.service
    DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
)

=== src/akonadictl/CMakeLists.txt ===
########### next target ###############

add_executable(akonadictl)
ecm_qt_declare_logging_category(akonadictl HEADER akonadictl_debug.h IDENTIFIER AKONADICTL_LOG CATEGORY_NAME org.kde.pim.akonadictl
        DESCRIPTION "akonadi (Akonadi Control)"
        OLD_CATEGORY_NAMES log_akonadictl
        EXPORT AKONADI
)

qt_add_dbus_interfaces(akonadictl_SRCS
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.ControlManager.xml
    ${Akonadi_SOURCE_DIR}/src/interfaces/org.freedesktop.Akonadi.Janitor.xml
)
target_sources(
    akonadictl
    PRIVATE
        ${akonadictl_SRCS}
        akonadistarter.cpp
        main.cpp
        akonadistarter.h
)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(
        akonadictl
        PROPERTIES
            UNITY_BUILD
                ON
    )
endif()

set_target_properties(
    akonadictl
    PROPERTIES
        MACOSX_BUNDLE
            FALSE
)
set_target_properties(
    akonadictl
    PROPERTIES
        OUTPUT_NAME
            akonadictl
)
ecm_mark_nongui_executable(akonadictl)
target_link_libraries(
    akonadictl
    akonadi_shared
    KPim6::AkonadiPrivate
    KF6::CoreAddons
    Qt::Core
    Qt::DBus
)

install(
    TARGETS
        akonadictl
        ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

=== debian/changelog ===
akonadi (4:25.11.80-0ubuntu1) resolute; urgency=medium

  * New upstream (beta) release (25.11.80)

 -- Rik Mills <rikmills@kde.org>  Sun, 16 Nov 2025 07:51:01 +0000

akonadi (4:25.08.3-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Nov 2025 15:18:56 +0000

=== debian/control ===
Source: akonadi
Section: libs
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sune Vuorela <debian@pusling.com>,
           Sandro Knauß <hefee@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               default-libmysqlclient-dev,
               dh-apparmor,
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               extra-cmake-modules (>= 6.6.0~),
               gettext,
               libaccounts-qt6-dev (>= 1.16~),
               libboost-dev (>= 1.34.0~),
               libkaccounts6-dev (>= 4:25.11.80~),
               libkf6config-dev (>= 6.6.0~),
               libkf6configwidgets-dev (>= 6.6.0~),
               libkf6coreaddons-dev (>= 6.6.0~),
               libkf6crash-dev (>= 6.6.0~),
               libkf6i18n-dev (>= 6.6.0~),
               libkf6iconthemes-dev (>= 6.6.0~),
               libkf6itemmodels-dev (>= 6.6.0~),
               libkf6widgetsaddons-dev (>= 6.6.0~),
               libkf6xmlgui-dev (>= 6.6.0~),
               liblzma-dev (>= 5.0.0~),
               libpq-dev,
               libsignon-qt6-dev,
               libxml2-dev,
               libxml2-utils,
               libxslt1-dev,
               pkgconf,
               qt6-base-dev (>= 6.7.0~),
               qt6-base-private-dev (>= 6.7.0~),
               qt6-tools-dev (>= 6.6.0~),
               shared-mime-info (>= 1.8~),
               xsltproc,
Standards-Version: 4.7.0
Homepage: https://invent.kde.org/pim/akonadi
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/akonadi
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/akonadi
Rules-Requires-Root: no

Package: akonadi-backend-mysql
Section: misc
Architecture: all
Depends: default-mysql-client-core | virtual-mysql-client-core,
         default-mysql-server-core | virtual-mysql-server-core,
         libqt6sql6-mysql,
         ${misc:Depends},
Recommends: akonadi-server,
Description: MySQL storage backend for Akonadi
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package installs everything what's needed for Akonadi to work with MySQL
 as underlying data storage engine. By default, a local MySQL server instance
 will be started for each user. Alternatively, connection to an external MySQL
 database is supported as well.

Package: akonadi-backend-postgresql
Section: misc
Architecture: all
Depends: libqt6sql6-psql, ${misc:Depends},
Recommends: akonadi-server, postgresql,
Description: PostgreSQL storage backend for Akonadi
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package installs everything what's needed for Akonadi to work with
 PostgreSQL as underlying data storage engine. By default, a local PostgreSQL
 server instance will be started for each user. Alternatively, connection to an
 external PostgreSQL database is supported as well.

Package: akonadi-backend-sqlite
Section: misc
Architecture: all
Depends: libqt6sql6-sqlite, ${misc:Depends}, ${shlibs:Depends},
Recommends: akonadi-server,
Description: SQLite storage backend for Akonadi
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package installs everything what's needed for Akonadi to work with SQLite
 as underlying data storage engine. Since SQLite is an embedded database
 engine, a separate SQL server daemon is not necessary.
 .
 In addition, the package contains an improved QSql driver for SQLite named
 "QSQLite3". It can be used by any application that needs to access SQLite
 databases via standard Qt QSql framework.

Package: akonadi-server
Section: net
Architecture: any
Depends: akonadi-backend-sqlite (= ${source:Version}) | akonadi-backend-mysql (= ${source:Version}) | akonadi-backend-postgresql (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: akonadi-backend-mysql (= ${source:Version}),
          akonadi-backend-postgresql (= ${source:Version}),
          akonadi-backend-sqlite (= ${source:Version}),
Description: Akonadi PIM storage service
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package contains the Akonadi PIM storage server and associated programs.

Package: libakonadi-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Akonadi arch independent data
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package ships arch independent data like translations etc.

Package: libakonadi-dev
Section: libdevel
Architecture: any
Depends: libakonadiserver-dev (>= ${binary:Version}),
         libkf6config-dev (>= 6.6.0~),
         libkf6configwidgets-dev (>= 6.6.0~),
         libkf6coreaddons-dev (>= 6.6.0~),
         libkf6itemmodels-dev (>= 6.6.0~),
         libkf6xmlgui-dev (>= 6.6.0~),
         libkpim6akonadiagentbase6 (= ${binary:Version}),
         libkpim6akonadiagentwidgetbase6 (= ${binary:Version}),
         libkpim6akonadicore6 (= ${binary:Version}),
         libkpim6akonadiwidgets6 (= ${binary:Version}),
         libkpim6akonadixml6 (= ${binary:Version}),
         qt6-base-dev (>= 6.7.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: libkf5akonadi-dev,
Replaces: libkf5akonadi-dev,
Description: development files for the KDE Development Platform PIM libraries
 This package contains development files for building software that uses
 the KDE Development Platform Personal Information Management libraries.
 .
 This package is part of the KDE Development Platform PIM libraries module.

Package: libakonadi-dev-bin
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends},
Breaks: libkf5akonadi-dev-bin,
Replaces: libkf5akonadi-dev-bin,
Description: Additional development binaries for the Akonadi KDE PIM libraries
 This package contains development files for building software that uses
 the KDE Development Platform Personal Information Management libraries.
 .
 This package is part of the KDE Development Platform PIM libraries module.
 .
 It contains files to run Akonadi based tests.

Package: libkpim6akonadiagentbase6
Provides: ${ABI:VirtualPackage},
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Akonadi agent base library
 This library contains classes to implement agents for the Akonadi PIM
 data server.
 .
 This package is part of the KDE Development Platform PIM libraries module.

Package: libkpim6akonadiagentwidgetbase6
Provides: ${ABI:VirtualPackage},
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Akonadi agent widget base library
 This library contains classes to implement agents for the Akonadi PIM
 data server.
 .
 This package is part of the KDE Development Platform PIM libraries module.

Package: libkpim6akonadicore6
Provides: ${ABI:VirtualPackage},
Architecture: any
Multi-Arch: same
Depends: libakonadi-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libkpim6akonadiwidgets6 (= ${binary:Version}),
Description: Akonadi core library
 This library contains Akonadi PIM data server core classes.
 .
 This package is part of the KDE Development Platform PIM libraries module.

Package: libkpim6akonadiprivate6
Provides: ${ABI:VirtualPackage},
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Suggests: akonadi-server (= ${binary:Version}),
Description: libraries for the Akonadi PIM storage service
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package contains libraries used by the Akonadi PIM storage service.

Package: libakonadiserver-dev
Section: libdevel
Architecture: any
Depends: libkpim6akonadiprivate6 (= ${binary:Version}),
         ${misc:Depends},
Breaks: libkf5akonadiserver-dev,
Replaces: libkf5akonadiserver-dev,
Description: development files for the Akonadi PIM storage service
 Akonadi is an extensible cross-desktop Personal Information Management (PIM)
 storage service. It provides a common framework for applications to store and
 access mail, calendars, addressbooks, and other PIM data.
 .
 This package contains development files for building software that uses the
 Akonadi PIM storage service.

Package: libkpim6akonadiwidgets6
Provides: ${ABI:VirtualPackage},
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Akonadi widgets library
 This library contains standard widgets for the Akonadi PIM data server.
 .
 This package is part of the KDE Development Platform PIM libraries module.

Package: libkpim6akonadixml6
Provides: ${ABI:VirtualPackage},
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Akonadi XML helper library
 This library provides XML helpers using the Akonadi PIM data server.
 .
 This package is part of the KDE Development Platform PIM libraries module.
